#include <iostream>
#include <cmath>
using namespace std;
int vngrd(int a2[],int i,int j,int x);
int main()
{
    int r=0,g,c=1;
    int n,m,x,i=0,a,b,y,f;
    int a1[1000];
    cin >> n>>m>>x;
    int a2[1000];
    for(int j=0;j<x;j++)
    {
        cin >> a >> b;
        a2[i]=a*10+b;
        i++;
    }
    for(int ir=1;ir<=n;ir++)
    {
        for(int j=1;j<=m;j++)
        {
            f=vngrd(a2,ir,j,i);
            a1[r]=f;
            r++;
        }
    }
    for(int s=0;s<r-1;s++)
    {
        g=s;
        for(int k=s;k<r;k++)
        {
            if(a1[g]>a1[k])
            {
                g=k;
            }
        }
        swap(a1[s],a1[g]);

    }
    for(int ks=0;ks<(r-x)-1;ks++)
    {
        if(abs(a1[ks]-a1[ks+1])>1)
        {
            c+=1;
        }
    }
    cout << c;
    return 0;
}
int vngrd(int a2[],int i,int j,int x)
{
    int y;
    for(int m=0;m<x;m++)
    {
        if(a2[m]!=(i*10+j))
        {
            y=1;
        }
        else
        {
            y=0;
            break;
        }
    }
    if(y==1)
    {
        return i+j;
    }
}